<template>
	<span class="ts-hours-control">
		<span v-if="props.plain">{{ formatted }}</span>
		<time-control
			v-if="!props.plain"
			:min="props.min"
			:model-value="modelValue"
			@update:model-value="(val) => emits('update:modelValue', val)"
			@reset="() => emits('reset')"
		/>
	</span>
</template>

<script lang="ts" setup>
import { computed, PropType } from 'vue-demi';
import { DurationTime, durationTotalHoursRounded } from '../../../lib/utils';
import TimeControl from "./TimeControl.vue";

const props = defineProps({
	modelValue: Object as PropType<DurationTime | undefined>,
	plain: {
		type: Boolean,
		default: false
	},
	min: {
		type: Object as PropType<DurationTime>,
		default: () => DurationTime.zero()
	}
});
const emits = defineEmits<{
	(e: "update:modelValue", val: DurationTime): void;
	(e: "reset"): void;
}>();

const formatted = computed(() => props.modelValue && durationTotalHoursRounded(props.modelValue) || '');

</script>